/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   property-range-document.html
 */

/// <reference path="../polymer/types/polymer-element.d.ts" />
/// <reference path="../polymer/types/lib/elements/dom-if.d.ts" />
/// <reference path="../polymer/types/lib/elements/dom-repeat.d.ts" />
/// <reference path="../iron-flex-layout/iron-flex-layout.d.ts" />
/// <reference path="../markdown-styles/markdown-styles.d.ts" />
/// <reference path="../marked-element/marked-element.d.ts" />
/// <reference path="../api-annotation-document/api-annotation-document.d.ts" />
/// <reference path="../amf-helper-mixin/amf-helper-mixin.d.ts" />
/// <reference path="api-type-document.d.ts" />
/// <reference path="property-document-mixin.d.ts" />

declare namespace ApiElements {

  /**
   * `property-range-document`
   *
   * Renders a documentation for a shape property of AMF model.
   *
   * ## Styling
   *
   * `<property-range-document>` provides the following custom properties and mixins for styling:
   *
   * Custom property | Description | Default
   * ----------------|-------------|----------
   * `--property-range-document` | Mixin applied to this elment | `{}`
   * `--api-type-document-type-attribute-color` | Color of each attribute that describes a property | `#616161`
   * `--api-type-document-examples-title-color` | Color of examples section title | ``
   * `--api-type-document-examples-border-color` | Example section border color | `transparent`
   * `--code-background-color` | Background color of the examples section | ``
   * `--arc-font-body1` | Mixin applied to an example name label | `{}`
   * `--arc-font-body2` | Mixin applied to the examples section title | `{}`
   */
  class PropertyRangeDocument extends
    ArcBehaviors.PropertyDocumentMixin(
    ApiElements.AmfHelperMixin(
    Polymer.Element)) {

    /**
     * Computed value, true if there is a list of examples
     */
    readonly hasExamples: boolean|null|undefined;

    /**
     * Computed list of examples
     */
    readonly examples: Array<object|null>|null;

    /**
     * Computed value form the shape. True if the property is ENUM.
     */
    readonly isEnum: boolean|null|undefined;

    /**
     * Computed value, true if current property is an union.
     */
    readonly isUnion: boolean|null|undefined;

    /**
     * Computed value, true if current property is an object.
     */
    readonly isObject: boolean|null|undefined;

    /**
     * Computed value, true if current property is an array.
     */
    readonly isArray: boolean|null|undefined;

    /**
     * Computed value, true if current property is a File.
     */
    readonly isFile: boolean|null|undefined;

    /**
     * Should be set if described properties has a parent type.
     * This is used when recursively iterating over properties.
     */
    parentTypeName: string|null|undefined;

    /**
     * Computed values for list of enums.
     * Enums are list of types names.
     */
    readonly enumValues: Array<String|null>|null;

    /**
     * Computes properties to render Array items documentation.
     *
     * @param range Range object of current shape.
     * @returns List of Array items.
     */
    _computeArrayProperties(range: object|null): Array<object|null>|null|undefined;

    /**
     * Computes value for `isUnion` property.
     * Union type is identified as a `http://raml.org/vocabularies/shapes#UnionShape`
     * type.
     *
     * @param range Range object of current shape.
     */
    _computeIsUnion(range: object|null): Boolean|null;

    /**
     * Computes value for `isObject` property.
     * Object type is identified as a `http://raml.org/vocabularies/shapes#NodeShape`
     * type.
     *
     * @param range Range object of current shape.
     */
    _computeIsObject(range: object|null): Boolean|null;

    /**
     * Computes value for `isArray` property.
     * Array type is identified as a `http://raml.org/vocabularies/shapes#ArrayShape`
     * type.
     *
     * @param range Range object of current shape.
     */
    _computeIsArray(range: object|null): Boolean|null;

    /**
     * Computes value if a property exists in a model
     *
     * @param model An object to test
     * @param key Property name to look for
     */
    _hasProperty(model: object|null, key: String|null): Boolean|null;

    /**
     * Computes value for `hasExamples`.
     *
     * @param range Range object of current shape.
     */
    _computeHasExamples(range: object|null): Boolean|null;

    /**
     * Computes list of examples for the property.
     *
     * @param hasExamples Current value of `hasExamples`
     * @param range Range object of current shape.
     * @returns List of examples.
     * Each object has `value` property as a string example value. Also, it has
     * `hasName` property describing if `name` property is set.
     */
    _computeExamplesValue(hasExamples: Boolean|null, range: object|null): Array<object|null>|null|undefined;

    /**
     * Computes value `isEnum` property.
     *
     * @param range Current `range` object.
     * @returns Curently it always returns `false`
     */
    _computeIsEnum(range: object|null): Boolean|null;

    /**
     * Computes value for `isFile` property
     *
     * @param range Range object of current shape.
     */
    _computeIsFile(range: object|null): Boolean|null;
    _computeObjectProperties(range: any): any;

    /**
     * Computes value for `enumValues` property.
     *
     * @param isEnum Current value of `isEnum` property
     * @param range Range object of current shape.
     * @returns List of enum types.
     */
    _computeEnumValues(isEnum: Boolean|null, range: object|null): Array<String|null>|null|undefined;

    /**
     * Computes example value to set on `marked-element`.
     * It adds "```" to create a code block.
     *
     * @param value Value to display
     */
    _computeExampleDisplay(value: String|null): String|null|undefined;
  }
}

interface HTMLElementTagNameMap {
  "property-range-document": ApiElements.PropertyRangeDocument;
}
